package com.tptj.demo.hg.global.filter;


import com.fanruan.api.log.LogKit;
import com.fr.decision.fun.GlobalRequestFilterProvider;
import com.fr.decision.fun.impl.AbstractGlobalRequestFilterProvider;
import com.fr.intelli.record.Focus;
import com.fr.record.analyzer.EnableMetrics;
import com.fr.web.utils.WebUtils;
import org.jetbrains.annotations.NotNull;

import javax.servlet.FilterChain;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
 * @author 秃破天际
 * @version 10.0
 * Created by 秃破天际 on 2021-03-26
 * 注：filter除极特殊情况外，只能用于请求的预处理、转换或重定向。不得用于生成一个新的web业务功能接口
 **/
@EnableMetrics
public class Demo extends AbstractGlobalRequestFilterProvider {
    @Override
    public String filterName() {
        return "A Demo";
    }

    @Override
    public String[] urlPatterns() {
        return new String[]{"/*"};
    }

    @Override
    @Focus(id="com.tptj.demo.hg.global.filter.v10",text = "global filter")
    public void doFilter( HttpServletRequest req, HttpServletResponse res, FilterChain chain ){
        LogKit.info( "sort 1,path={},ip={}", req.getPathInfo(), WebUtils.getIpAddr(req) );
        try{
            chain.doFilter(req,res);
        }catch (Exception e){
            LogKit.error(e.getMessage(),e);
        }
    }

    /**
     * 可选实现的多个filter排序（执行顺序）的方法
     * @param other
     * @return 0 相等，大于0是自身优先 小于0 是other优先
     */
    @Override
    public int compareTo(@NotNull GlobalRequestFilterProvider other ){
        return super.compareTo(other);
    }
}
